#!/usr/bin/perl -w
# 
# sb::Data - Module for Serene Bach
# == written by T.Otani <ootani@segausers.gr.jp> ===
# == Copyright (C) 2004 SimpleBoxes/SerendipityNZ ==

package sb::Data;

use strict;

# ==================================================
# // module version
# ==================================================
use vars qw( $VERSION @ISA );
$VERSION = '0.00';
# 0.00 [2005/02/02] generated

# ==================================================
# // configuration for inheritance / dependancy
# ==================================================
use sb::Language ();
use sb::Driver ();
# ==================================================
# // declaration for class member
# ==================================================
# ==================================================
# // public functions
# ==================================================
sub load {
	my $class = shift() . '::' . shift();
	eval("require $class;");
	my $obj = $class->alloc() if (!$@);
	return() if (!$obj);
	my %param = ( # ϥѥ᡼
		'cond'   => {},     # о
		'id'     => undef,  # id  (ܺ٥ǡ)
		'logic'  => 'and',  # ׷黻
		'bgn'    => 0,      # ϰϻγֹ
		'num'    => -1,     # ϰϻμ
		'sort'   => 'id',   # ȹ
		'order'  => 0,      # ¤ӽ
		'detail' => undef,  # ܺ٥ǡɽФ
		'table'  => ['id'], # ƥĥꥹȥơ֥
		@_
	);
	$param{'table'} = [$obj->elements]; # ƥĥꥹȥơ֥ν
	my @array = sb::Driver->get->load($class,%param);
	return  ($#array == 0) ?  $array[0] : @array;
}
sub load_as_hash {
	my $class = shift;
	my @array = $class->load(shift(),@_);
	my %hash  = ();
	foreach my $obj (@array) {
		$hash{$obj->id} = $obj;
	}
	return( %hash );
}
sub matched {
	return sb::Driver->get->matched_number;
}
sub update {
	my $class = shift;
	my @objs  = @_; # ϥѥ᡼(¸륪֥ȷ)
	sb::Driver->get->save(@objs);
}
sub add {
	my $class = shift() . '::' . shift();
	my %param = @_;
	eval("require $class;");
	my $obj = $class->alloc() if (!$@);
	return( undef ) if (!$obj);
	$param{'id'} = sb::Driver->get->new_id($class);
	$obj->add_new(%param);
	return( $obj );
}
# ==================================================
# // private functions
# ==================================================
1; # end of package
